/*
 * Turbo Programmer Utilities, turbo-prog-utils, www.bladox.com 
 *
 * Copyright (C) 2004 BLADOX, s.r.o.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#ifndef _USBPROG_ISP_H_
#define _USBPROG_ISP_H_

void ispSckDelay();
void ispOutReset(u8 resetValue);
void ispOutSck(u8 sckValue);
u8 ispSendRecv(u8 b);
u16 ispSend (u8* queue, int queueSize);
void ispPulseSck(void);
void ispPulseReset(void);

u8 ispEnableAvr(void);
u8 ispGetPartInfo(u8 addr);
u8 ispReadByteFlash(unsigned long addr);
u8 ispReadChunkFlash(unsigned long addr,u8 *chunk, u8 chunkSize);
u8 ispReadByteEeprom(unsigned long addr);
u8 ispReadChunkEeprom(unsigned long addr,u8 *chunk, u8 chunkSize);
u8 ispReadLockBits();
u8 ispReadFuseLowBits();
u8 ispReadFuseHighBits();
u8 ispReadFuseExtBits();
u8 ispReadCalByte(u8 addr);
void ispWriteOldFuseBits(u8 val);
void ispWriteFuseLowBits(u8 val);
void ispWriteFuseHighBits(u8 val);
void ispWriteFuseExtBits(u8 val);
void ispChipErase();
void ispWriteLockBits(u8 bits);
void ispWriteByteFlash(unsigned long addr, u8 val);
u8 ispWriteChunkFlash(unsigned long addr,u8 *chunk, u8 chunkSize);
u8 ispWriteByteEeprom(unsigned long addr, u8 val);
u8 ispWriteChunkEeprom(unsigned long addr,u8 *chunk, u8 chunkSize);
void ispWriteProgramMemoryPage(unsigned long pageAddr);

#endif
